JUCE: LookAndFeel_V1 Class Reference

JUCE

Public Member Functions | List of all members
LookAndFeel_V1 Class Reference
juce_gui_basics » lookandfeel

The original JUCE look-and-feel, as used back from 2002 to about 2007ish. More...

`#include <juce_LookAndFeel_V1.h>`

Inheritance diagram for LookAndFeel_V1:

## Public Member Functions
| LookAndFeel_V1 ()
| ~LookAndFeel_V1 () override
void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the contents of a standard ToggleButton. More...
void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &textToShow) override
| Draws a progress bar. More...
void | drawScrollbarButton (Graphics &, ScrollBar &, int width, int height, int buttonDirection, bool isScrollbarVertical, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws one of the buttons on a scrollbar. More...
void | drawScrollbar (Graphics &, ScrollBar &, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown) override
| Draws the thumb area of a scrollbar. More...
ImageEffectFilter * | getScrollbarEffect () override
| Returns the component effect to use for a scrollbar. More...
void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &) override
void | drawPopupMenuBackground (Graphics &, int width, int height) override
| Fills the background of a popup menu component. More...
void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &) override
void | drawComboBox (Graphics &, int width, int height, bool isButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &) override
Font | getComboBoxFont (ComboBox &) override
void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
int | getSliderThumbRadius (Slider &) override
Button * | createSliderButton (Slider &, bool isIncrement) override
ImageEffectFilter * | getSliderEffect (Slider &) override
void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging) override
Button * | createDocumentWindowButton (int buttonType) override
void | positionDocumentWindowButtons (DocumentWindow &, int titleBarX, int titleBarY, int titleBarW, int titleBarH, Button *minimiseButton, Button *maximiseButton, Button *closeButton, bool positionTitleBarButtonsOnLeft) override
Public Member Functions inherited from LookAndFeel_V2
| LookAndFeel_V2 ()
| ~LookAndFeel_V2 () override
void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
Font | getTextButtonFont (TextButton &, int buttonHeight) override
void | drawButtonText (Graphics &, TextButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the text for a TextButton. More...
int | getTextButtonWidthToFitText (TextButton &, int buttonHeight) override
void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws the contents of a standard ToggleButton. More...
void | changeToggleButtonWidthToFitText (ToggleButton &) override
void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
void | drawDrawableButton (Graphics &, DrawableButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
AlertWindow * | createAlertWindow (const String &title, const String &message, const String &button1, const String &button2, const String &button3, MessageBoxIconType iconType, int numButtons, Component *associatedComponent) override
void | drawAlertBox (Graphics &, AlertWindow &, const Rectangle< int > &textArea, TextLayout &) override
int | getAlertBoxWindowFlags () override
Array< int > | getWidthsForTextButtons (AlertWindow &, const Array< TextButton * > &) override
int | getAlertWindowButtonHeight () override
Font | getAlertWindowTitleFont () override
| Override this function to supply a custom font for the alert window title. More...
Font | getAlertWindowMessageFont () override
| Override this function to supply a custom font for the alert window message. More...
Font | getAlertWindowFont () override
void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &textToShow) override
| Draws a progress bar. More...
void | drawSpinningWaitAnimation (Graphics &, const Colour &colour, int x, int y, int w, int h) override
| Draws a small image that spins to indicate that something's happening. More...
bool | isProgressBarOpaque (ProgressBar &) override
bool | areScrollbarButtonsVisible () override
void | drawScrollbarButton (Graphics &, ScrollBar &, int width, int height, int buttonDirection, bool isScrollbarVertical, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown) override
| Draws one of the buttons on a scrollbar. More...
void | drawScrollbar (Graphics &, ScrollBar &, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown) override
| Draws the thumb area of a scrollbar. More...
ImageEffectFilter * | getScrollbarEffect () override
| Returns the component effect to use for a scrollbar. More...
int | getMinimumScrollbarThumbSize (ScrollBar &) override
| Returns the minimum length in pixels to use for a scrollbar thumb. More...
int | getDefaultScrollbarWidth () override
| Returns the default thickness to use for a scrollbar. More...
int | getScrollbarButtonSize (ScrollBar &) override
| Returns the length in pixels to use for a scrollbar button. More...
Path | getTickShape (float height) override
| Returns a tick shape for use in yes/no boxes, etc. More...
Path | getCrossShape (float height) override
| Returns a cross shape for use in yes/no boxes, etc. More...
void | drawTreeviewPlusMinusBox (Graphics &, const Rectangle< float > &area, Colour backgroundColour, bool isOpen, bool isMouseOver) override
bool | areLinesDrawnForTreeView (TreeView &) override
int | getTreeViewIndentSize (TreeView &) override
void | fillTextEditorBackground (Graphics &, int width, int height, TextEditor &) override
void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &) override
CaretComponent * | createCaretComponent (Component *keyFocusOwner) override
const Drawable * | getDefaultFolderImage () override
const Drawable * | getDefaultDocumentFileImage () override
AttributedString | createFileChooserHeaderText (const String &title, const String &instructions) override
void | drawFileBrowserRow (Graphics &, int width, int height, const File &file, const String &filename, Image *icon, const String &fileSizeDescription, const String &fileTimeDescription, bool isDirectory, bool isItemSelected, int itemIndex, DirectoryContentsDisplayComponent &) override
Button * | createFileBrowserGoUpButton () override
void | layoutFileBrowserComponent (FileBrowserComponent &, DirectoryContentsDisplayComponent *, FilePreviewComponent *, ComboBox *currentPathBox, TextEditor *filenameBox, Button *goUpButton) override
void | drawBubble (Graphics &, BubbleComponent &, const Point< float > &tip, const Rectangle< float > &body) override
void | drawLasso (Graphics &, Component &) override
void | drawPopupMenuBackground (Graphics &, int width, int height) override
| Fills the background of a popup menu component. More...
void | drawPopupMenuBackgroundWithOptions (Graphics &, int width, int height, const PopupMenu::Options &) override
| Fills the background of a popup menu component. More...
void | drawPopupMenuItem (Graphics &, const Rectangle< int > &area, bool isSeparator, bool isActive, bool isHighlighted, bool isTicked, bool hasSubMenu, const String &text, const String &shortcutKeyText, const Drawable *icon, const Colour *textColour) override
| Draws one of the items in a popup menu. More...
void | drawPopupMenuItemWithOptions (Graphics &, const Rectangle< int > &area, bool isHighlighted, const PopupMenu::Item &item, const PopupMenu::Options &) override
| Draws one of the items in a popup menu. More...
void | drawPopupMenuSectionHeader (Graphics &, const Rectangle< int > &area, const String &sectionName) override
void | drawPopupMenuSectionHeaderWithOptions (Graphics &, const Rectangle< int > &area, const String &sectionName, const PopupMenu::Options &) override
Font | getPopupMenuFont () override
| Returns the size and style of font to use in popup menus. More...
void | drawPopupMenuUpDownArrow (Graphics &, int width, int height, bool isScrollUpArrow) override
void | drawPopupMenuUpDownArrowWithOptions (Graphics &, int width, int height, bool isScrollUpArrow, const PopupMenu::Options &) override
void | getIdealPopupMenuItemSize (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight) override
| Finds the best size for an item in a popup menu. More...
void | getIdealPopupMenuItemSizeWithOptions (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const PopupMenu::Options &) override
| Finds the best size for an item in a popup menu. More...
int | getMenuWindowFlags () override
void | preparePopupMenuWindow (Component &) override
void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &) override
int | getMenuBarItemWidth (MenuBarComponent &, int itemIndex, const String &itemText) override
Font | getMenuBarFont (MenuBarComponent &, int itemIndex, const String &itemText) override
int | getDefaultMenuBarHeight () override
void | drawMenuBarItem (Graphics &, int width, int height, int itemIndex, const String &itemText, bool isMouseOverItem, bool isMenuOpen, bool isMouseOverBar, MenuBarComponent &) override
Component * | getParentComponentForMenuOptions (const PopupMenu::Options &options) override
bool | shouldPopupMenuScaleWithTargetComponent (const PopupMenu::Options &options) override
| Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor. More...
int | getPopupMenuBorderSize () override
int | getPopupMenuBorderSizeWithOptions (const PopupMenu::Options &) override
void | drawPopupMenuColumnSeparatorWithOptions (Graphics &g, const Rectangle< int > &bounds, const PopupMenu::Options &) override
| Implement this to draw some custom decoration between the columns of the popup menu. More...
int | getPopupMenuColumnSeparatorWidthWithOptions (const PopupMenu::Options &) override
| Return the amount of space that should be left between popup menu columns. More...
void | drawComboBox (Graphics &, int width, int height, bool isMouseButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &) override
Font | getComboBoxFont (ComboBox &) override
Label * | createComboBoxTextBox (ComboBox &) override
void | positionComboBoxText (ComboBox &, Label &) override
PopupMenu::Options | getOptionsForComboBoxPopupMenu (ComboBox &, Label &) override
void | drawComboBoxTextWhenNothingSelected (Graphics &, ComboBox &, Label &) override
void | drawLabel (Graphics &, Label &) override
Font | getLabelFont (Label &) override
BorderSize< int > | getLabelBorderSize (Label &) override
void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawLinearSliderBackground (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawLinearSliderThumb (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &) override
void | drawRotarySlider (Graphics &, int x, int y, int width, int height, float sliderPosProportional, float rotaryStartAngle, float rotaryEndAngle, Slider &) override
int | getSliderThumbRadius (Slider &) override
Button * | createSliderButton (Slider &, bool isIncrement) override
Label * | createSliderTextBox (Slider &) override
ImageEffectFilter * | getSliderEffect (Slider &) override
Font | getSliderPopupFont (Slider &) override
int | getSliderPopupPlacement (Slider &) override
Slider::SliderLayout | getSliderLayout (Slider &) override
Rectangle< int > | getTooltipBounds (const String &tipText, Point< int > screenPos, Rectangle< int > parentArea) override
| returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area. More...
void | drawTooltip (Graphics &, const String &text, int width, int height) override
Button * | createFilenameComponentBrowseButton (const String &text) override
void | layoutFilenameComponent (FilenameComponent &, ComboBox *filenameBox, Button *browseButton) override
void | drawConcertinaPanelHeader (Graphics &, const Rectangle< int > &area, bool isMouseOver, bool isMouseDown, ConcertinaPanel &, Component &panel) override
void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging) override
void | drawResizableFrame (Graphics &, int w, int h, const BorderSize< int > &) override
void | fillResizableWindowBackground (Graphics &, int w, int h, const BorderSize< int > &, ResizableWindow &) override
void | drawResizableWindowBorder (Graphics &, int w, int h, const BorderSize< int > &border, ResizableWindow &) override
void | drawDocumentWindowTitleBar (DocumentWindow &, Graphics &, int w, int h, int titleSpaceX, int titleSpaceW, const Image *icon, bool drawTitleTextOnLeft) override
Button * | createDocumentWindowButton (int buttonType) override
void | positionDocumentWindowButtons (DocumentWindow &, int titleBarX, int titleBarY, int titleBarW, int titleBarH, Button *minimiseButton, Button *maximiseButton, Button *closeButton, bool positionTitleBarButtonsOnLeft) override
std::unique_ptr< DropShadower > | createDropShadowerForComponent (Component &) override
| Creates a drop-shadower for a given component, if required. More...
std::unique_ptr< FocusOutline > | createFocusOutlineForComponent (Component &) override
| Creates a focus outline for a given component, if required. More...
void | drawStretchableLayoutResizerBar (Graphics &, int w, int h, bool isVerticalBar, bool isMouseOver, bool isMouseDragging) override
void | drawGroupComponentOutline (Graphics &, int w, int h, const String &text, const Justification &, GroupComponent &) override
int | getTabButtonSpaceAroundImage () override
int | getTabButtonOverlap (int tabDepth) override
int | getTabButtonBestWidth (TabBarButton &, int tabDepth) override
Rectangle< int > | getTabButtonExtraComponentBounds (const TabBarButton &, Rectangle< int > &textArea, Component &extraComp) override
void | drawTabButton (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
Font | getTabButtonFont (TabBarButton &, float height) override
void | drawTabButtonText (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown) override
void | drawTabbedButtonBarBackground (TabbedButtonBar &, Graphics &) override
void | drawTabAreaBehindFrontButton (TabbedButtonBar &, Graphics &, int w, int h) override
void | createTabButtonShape (TabBarButton &, Path &, bool isMouseOver, bool isMouseDown) override
void | fillTabButtonShape (TabBarButton &, Graphics &, const Path &, bool isMouseOver, bool isMouseDown) override
Button * | createTabBarExtrasButton () override
void | drawImageButton (Graphics &, Image *, int imageX, int imageY, int imageW, int imageH, const Colour &overlayColour, float imageOpacity, ImageButton &) override
void | drawTableHeaderBackground (Graphics &, TableHeaderComponent &) override
void | drawTableHeaderColumn (Graphics &, TableHeaderComponent &, const String &columnName, int columnId, int width, int height, bool isMouseOver, bool isMouseDown, int columnFlags) override
void | paintToolbarBackground (Graphics &, int width, int height, Toolbar &) override
Button * | createToolbarMissingItemsButton (Toolbar &) override
void | paintToolbarButtonBackground (Graphics &, int width, int height, bool isMouseOver, bool isMouseDown, ToolbarItemComponent &) override
void | paintToolbarButtonLabel (Graphics &, int x, int y, int width, int height, const String &text, ToolbarItemComponent &) override
void | drawPropertyPanelSectionHeader (Graphics &, const String &name, bool isOpen, int width, int height) override
void | drawPropertyComponentBackground (Graphics &, int width, int height, PropertyComponent &) override
void | drawPropertyComponentLabel (Graphics &, int width, int height, PropertyComponent &) override
Rectangle< int > | getPropertyComponentContentPosition (PropertyComponent &) override
int | getPropertyPanelSectionHeaderHeight (const String &sectionTitle) override
void | drawCallOutBoxBackground (CallOutBox &, Graphics &, const Path &path, Image &cachedImage) override
int | getCallOutBoxBorderSize (const CallOutBox &) override
float | getCallOutBoxCornerSize (const CallOutBox &) override
void | drawLevelMeter (Graphics &, int width, int height, float level) override
void | drawKeymapChangeButton (Graphics &, int width, int height, Button &, const String &keyDescription) override
Font | getSidePanelTitleFont (SidePanel &) override
Justification | getSidePanelTitleJustification (SidePanel &) override
Path | getSidePanelDismissButtonShape (SidePanel &) override
Public Member Functions inherited from LookAndFeel
| LookAndFeel ()
| Creates the default JUCE look and feel. More...
| ~LookAndFeel () override
| Destructor. More...
Colour | findColour (int colourId) const noexcept
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourId, Colour colour) noexcept
| Registers a colour to be used for a particular purpose. More...
bool | isColourSpecified (int colourId) const noexcept
| Returns true if the specified colour ID has been explicitly set using the setColour() method. More...
virtual Typeface::Ptr | getTypefaceForFont (const Font &)
| Returns the typeface that should be used for a given font. More...
void | setDefaultSansSerifTypeface (Typeface::Ptr newDefaultTypeface)
| Allows you to supply a default typeface that will be returned as the default sans-serif font. More...
void | setDefaultSansSerifTypefaceName (const String &newName)
| Allows you to change the default sans-serif font. More...
void | setUsingNativeAlertWindows (bool shouldUseNativeAlerts)
| Sets whether native alert windows (if available) or standard JUCE AlertWindows drawn with AlertWindow::LookAndFeelMethods will be used. More...
bool | isUsingNativeAlertWindows ()
| Returns true if native alert windows will be used (if available). More...
virtual void | drawSpinningWaitAnimation (Graphics &, const Colour &colour, int x, int y, int w, int h)=0
| Draws a small image that spins to indicate that something's happening. More...
virtual Path | getTickShape (float height)=0
| Returns a tick shape for use in yes/no boxes, etc. More...
virtual Path | getCrossShape (float height)=0
| Returns a cross shape for use in yes/no boxes, etc. More...
virtual std::unique_ptr< DropShadower > | createDropShadowerForComponent (Component &)=0
| Creates a drop-shadower for a given component, if required. More...
virtual std::unique_ptr< FocusOutline > | createFocusOutlineForComponent (Component &)=0
| Creates a focus outline for a given component, if required. More...
virtual MouseCursor | getMouseCursorFor (Component &)
| Override this to get the chance to swap a component's mouse cursor for a customised one. More...
virtual std::unique_ptr< LowLevelGraphicsContext > | createGraphicsContext (const Image &imageToRenderOn, Point< int > origin, const RectangleList< int > &initialClip)
| Creates a new graphics context object. More...
virtual void | playAlertSound ()
| Plays the system's default 'beep' noise, to alert the user about something very important. More...
Public Member Functions inherited from ScrollBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual bool | areScrollbarButtonsVisible ()=0
virtual void | drawScrollbarButton (Graphics &g, ScrollBar &scrollbar, int width, int height, int buttonDirection, bool isScrollbarVertical, bool isMouseOverButton, bool isButtonDown)=0
| Draws one of the buttons on a scrollbar. More...
virtual void | drawScrollbar (Graphics &g, ScrollBar &scrollbar, int x, int y, int width, int height, bool isScrollbarVertical, int thumbStartPosition, int thumbSize, bool isMouseOver, bool isMouseDown)=0
| Draws the thumb area of a scrollbar. More...
virtual ImageEffectFilter * | getScrollbarEffect ()=0
| Returns the component effect to use for a scrollbar. More...
virtual int | getMinimumScrollbarThumbSize (ScrollBar &)=0
| Returns the minimum length in pixels to use for a scrollbar thumb. More...
virtual int | getDefaultScrollbarWidth ()=0
| Returns the default thickness to use for a scrollbar. More...
virtual int | getScrollbarButtonSize (ScrollBar &)=0
| Returns the length in pixels to use for a scrollbar button. More...
Public Member Functions inherited from Button::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawButtonBackground (Graphics &, Button &, const Colour &backgroundColour, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
virtual Font | getTextButtonFont (TextButton &, int buttonHeight)=0
virtual int | getTextButtonWidthToFitText (TextButton &, int buttonHeight)=0
virtual void | drawButtonText (Graphics &, TextButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
| Draws the text for a TextButton. More...
virtual void | drawToggleButton (Graphics &, ToggleButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
| Draws the contents of a standard ToggleButton. More...
virtual void | changeToggleButtonWidthToFitText (ToggleButton &)=0
virtual void | drawTickBox (Graphics &, Component &, float x, float y, float w, float h, bool ticked, bool isEnabled, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
virtual void | drawDrawableButton (Graphics &, DrawableButton &, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
Public Member Functions inherited from ImageButton::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawImageButton (Graphics &, Image *, int imageX, int imageY, int imageW, int imageH, const Colour &overlayColour, float imageOpacity, ImageButton &)=0
Public Member Functions inherited from TextEditor::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | fillTextEditorBackground (Graphics &, int width, int height, TextEditor &)=0
virtual void | drawTextEditorOutline (Graphics &, int width, int height, TextEditor &)=0
virtual CaretComponent * | createCaretComponent (Component *keyFocusOwner)=0
Public Member Functions inherited from FileBrowserComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual const Drawable * | getDefaultFolderImage ()=0
virtual const Drawable * | getDefaultDocumentFileImage ()=0
virtual AttributedString | createFileChooserHeaderText (const String &title, const String &instructions)=0
virtual void | drawFileBrowserRow (Graphics &, int width, int height, const File &file, const String &filename, Image *optionalIcon, const String &fileSizeDescription, const String &fileTimeDescription, bool isDirectory, bool isItemSelected, int itemIndex, DirectoryContentsDisplayComponent &)=0
virtual Button * | createFileBrowserGoUpButton ()=0
virtual void | layoutFileBrowserComponent (FileBrowserComponent &browserComp, DirectoryContentsDisplayComponent *fileListComponent, FilePreviewComponent *previewComp, ComboBox *currentPathBox, TextEditor *filenameBox, Button *goUpButton)=0
Public Member Functions inherited from TreeView::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawTreeviewPlusMinusBox (Graphics &, const Rectangle< float > &area, Colour backgroundColour, bool isItemOpen, bool isMouseOver)=0
virtual bool | areLinesDrawnForTreeView (TreeView &)=0
virtual int | getTreeViewIndentSize (TreeView &)=0
Public Member Functions inherited from BubbleComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawBubble (Graphics &, BubbleComponent &, const Point< float > &positionOfTip, const Rectangle< float > &body)=0
Public Member Functions inherited from AlertWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual AlertWindow * | createAlertWindow (const String &title, const String &message, const String &button1, const String &button2, const String &button3, MessageBoxIconType iconType, int numButtons, Component *associatedComponent)=0
virtual void | drawAlertBox (Graphics &, AlertWindow &, const Rectangle< int > &textArea, TextLayout &)=0
virtual int | getAlertBoxWindowFlags ()=0
virtual Array< int > | getWidthsForTextButtons (AlertWindow &, const Array< TextButton * > &)=0
virtual int | getAlertWindowButtonHeight ()=0
virtual Font | getAlertWindowTitleFont ()=0
virtual Font | getAlertWindowMessageFont ()=0
virtual Font | getAlertWindowFont ()=0
Public Member Functions inherited from PopupMenu::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawPopupMenuBackground (Graphics &, int width, int height)
| Fills the background of a popup menu component. More...
virtual void | drawPopupMenuBackgroundWithOptions (Graphics &, int width, int height, const Options &)=0
| Fills the background of a popup menu component. More...
virtual void | drawPopupMenuItem (Graphics &, const Rectangle< int > &area, bool isSeparator, bool isActive, bool isHighlighted, bool isTicked, bool hasSubMenu, const String &text, const String &shortcutKeyText, const Drawable *icon, const Colour *textColour)
| Draws one of the items in a popup menu. More...
virtual void | drawPopupMenuItemWithOptions (Graphics &, const Rectangle< int > &area, bool isHighlighted, const Item &item, const Options &)=0
| Draws one of the items in a popup menu. More...
virtual void | drawPopupMenuSectionHeader (Graphics &, const Rectangle< int > &, const String &)
virtual void | drawPopupMenuSectionHeaderWithOptions (Graphics &, const Rectangle< int > &area, const String &sectionName, const Options &)=0
virtual Font | getPopupMenuFont ()=0
| Returns the size and style of font to use in popup menus. More...
virtual void | drawPopupMenuUpDownArrow (Graphics &, int width, int height, bool isScrollUpArrow)
virtual void | drawPopupMenuUpDownArrowWithOptions (Graphics &, int width, int height, bool isScrollUpArrow, const Options &)=0
virtual void | getIdealPopupMenuItemSize (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight)
| Finds the best size for an item in a popup menu. More...
virtual void | getIdealPopupMenuItemSizeWithOptions (const String &text, bool isSeparator, int standardMenuItemHeight, int &idealWidth, int &idealHeight, const Options &)=0
| Finds the best size for an item in a popup menu. More...
virtual int | getMenuWindowFlags ()=0
virtual void | drawMenuBarBackground (Graphics &, int width, int height, bool isMouseOverBar, MenuBarComponent &)=0
virtual int | getDefaultMenuBarHeight ()=0
virtual int | getMenuBarItemWidth (MenuBarComponent &, int itemIndex, const String &itemText)=0
virtual Font | getMenuBarFont (MenuBarComponent &, int itemIndex, const String &itemText)=0
virtual void | drawMenuBarItem (Graphics &, int width, int height, int itemIndex, const String &itemText, bool isMouseOverItem, bool isMenuOpen, bool isMouseOverBar, MenuBarComponent &)=0
virtual Component * | getParentComponentForMenuOptions (const Options &options)=0
virtual void | preparePopupMenuWindow (Component &newWindow)=0
virtual bool | shouldPopupMenuScaleWithTargetComponent (const Options &options)=0
| Return true if you want your popup menus to scale with the target component's AffineTransform or scale factor. More...
virtual int | getPopupMenuBorderSize ()
virtual int | getPopupMenuBorderSizeWithOptions (const Options &)=0
virtual void | drawPopupMenuColumnSeparatorWithOptions (Graphics &g, const Rectangle< int > &bounds, const Options &)=0
| Implement this to draw some custom decoration between the columns of the popup menu. More...
virtual int | getPopupMenuColumnSeparatorWidthWithOptions (const Options &)=0
| Return the amount of space that should be left between popup menu columns. More...
Public Member Functions inherited from ComboBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawComboBox (Graphics &, int width, int height, bool isButtonDown, int buttonX, int buttonY, int buttonW, int buttonH, ComboBox &)=0
virtual Font | getComboBoxFont (ComboBox &)=0
virtual Label * | createComboBoxTextBox (ComboBox &)=0
virtual void | positionComboBoxText (ComboBox &, Label &labelToPosition)=0
virtual PopupMenu::Options | getOptionsForComboBoxPopupMenu (ComboBox &, Label &)=0
virtual void | drawComboBoxTextWhenNothingSelected (Graphics &, ComboBox &, Label &)=0
Public Member Functions inherited from Label::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawLabel (Graphics &, Label &)=0
virtual Font | getLabelFont (Label &)=0
virtual BorderSize< int > | getLabelBorderSize (Label &)=0
Public Member Functions inherited from Slider::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawLinearSlider (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &)=0
virtual void | drawLinearSliderBackground (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle style, Slider &)=0
virtual void | drawLinearSliderThumb (Graphics &, int x, int y, int width, int height, float sliderPos, float minSliderPos, float maxSliderPos, const Slider::SliderStyle, Slider &)=0
virtual int | getSliderThumbRadius (Slider &)=0
virtual void | drawRotarySlider (Graphics &, int x, int y, int width, int height, float sliderPosProportional, float rotaryStartAngle, float rotaryEndAngle, Slider &)=0
virtual Button * | createSliderButton (Slider &, bool isIncrement)=0
virtual Label * | createSliderTextBox (Slider &)=0
virtual ImageEffectFilter * | getSliderEffect (Slider &)=0
virtual Font | getSliderPopupFont (Slider &)=0
virtual int | getSliderPopupPlacement (Slider &)=0
virtual SliderLayout | getSliderLayout (Slider &)=0
Public Member Functions inherited from ResizableWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawCornerResizer (Graphics &, int w, int h, bool isMouseOver, bool isMouseDragging)=0
virtual void | drawResizableFrame (Graphics &, int w, int h, const BorderSize< int > &)=0
virtual void | fillResizableWindowBackground (Graphics &, int w, int h, const BorderSize< int > &, ResizableWindow &)=0
virtual void | drawResizableWindowBorder (Graphics &, int w, int h, const BorderSize< int > &border, ResizableWindow &)=0
Public Member Functions inherited from DocumentWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawDocumentWindowTitleBar (DocumentWindow &, Graphics &, int w, int h, int titleSpaceX, int titleSpaceW, const Image *icon, bool drawTitleTextOnLeft)=0
virtual Button * | createDocumentWindowButton (int buttonType)=0
virtual void | positionDocumentWindowButtons (DocumentWindow &, int titleBarX, int titleBarY, int titleBarW, int titleBarH, Button *minimiseButton, Button *maximiseButton, Button *closeButton, bool positionTitleBarButtonsOnLeft)=0
Public Member Functions inherited from TooltipWindow::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual Rectangle< int > | getTooltipBounds (const String &tipText, Point< int > screenPos, Rectangle< int > parentArea)=0
| returns the bounds for a tooltip at the given screen coordinate, constrained within the given desktop area. More...
virtual void | drawTooltip (Graphics &, const String &text, int width, int height)=0
Public Member Functions inherited from TabbedButtonBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual int | getTabButtonSpaceAroundImage ()=0
virtual int | getTabButtonOverlap (int tabDepth)=0
virtual int | getTabButtonBestWidth (TabBarButton &, int tabDepth)=0
virtual Rectangle< int > | getTabButtonExtraComponentBounds (const TabBarButton &, Rectangle< int > &textArea, Component &extraComp)=0
virtual void | drawTabButton (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown)=0
virtual Font | getTabButtonFont (TabBarButton &, float height)=0
virtual void | drawTabButtonText (TabBarButton &, Graphics &, bool isMouseOver, bool isMouseDown)=0
virtual void | drawTabbedButtonBarBackground (TabbedButtonBar &, Graphics &)=0
virtual void | drawTabAreaBehindFrontButton (TabbedButtonBar &, Graphics &, int w, int h)=0
virtual void | createTabButtonShape (TabBarButton &, Path &path, bool isMouseOver, bool isMouseDown)=0
virtual void | fillTabButtonShape (TabBarButton &, Graphics &, const Path &path, bool isMouseOver, bool isMouseDown)=0
virtual Button * | createTabBarExtrasButton ()=0
Public Member Functions inherited from PropertyComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawPropertyPanelSectionHeader (Graphics &, const String &name, bool isOpen, int width, int height)=0
virtual void | drawPropertyComponentBackground (Graphics &, int width, int height, PropertyComponent &)=0
virtual void | drawPropertyComponentLabel (Graphics &, int width, int height, PropertyComponent &)=0
virtual Rectangle< int > | getPropertyComponentContentPosition (PropertyComponent &)=0
virtual int | getPropertyPanelSectionHeaderHeight (const String &sectionTitle)=0
Public Member Functions inherited from FilenameComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual Button * | createFilenameComponentBrowseButton (const String &text)=0
virtual void | layoutFilenameComponent (FilenameComponent &, ComboBox *filenameBox, Button *browseButton)=0
Public Member Functions inherited from GroupComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawGroupComponentOutline (Graphics &, int w, int h, const String &text, const Justification &, GroupComponent &)=0
Public Member Functions inherited from TableHeaderComponent::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawTableHeaderBackground (Graphics &, TableHeaderComponent &)=0
virtual void | drawTableHeaderColumn (Graphics &, TableHeaderComponent &, const String &columnName, int columnId, int width, int height, bool isMouseOver, bool isMouseDown, int columnFlags)=0
Public Member Functions inherited from CallOutBox::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawCallOutBoxBackground (CallOutBox &, Graphics &, const Path &, Image &)=0
virtual int | getCallOutBoxBorderSize (const CallOutBox &)=0
virtual float | getCallOutBoxCornerSize (const CallOutBox &)=0
Public Member Functions inherited from Toolbar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | paintToolbarBackground (Graphics &, int width, int height, Toolbar &)=0
virtual Button * | createToolbarMissingItemsButton (Toolbar &)=0
virtual void | paintToolbarButtonBackground (Graphics &, int width, int height, bool isMouseOver, bool isMouseDown, ToolbarItemComponent &)=0
virtual void | paintToolbarButtonLabel (Graphics &, int x, int y, int width, int height, const String &text, ToolbarItemComponent &)=0
Public Member Functions inherited from ConcertinaPanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawConcertinaPanelHeader (Graphics &, const Rectangle< int > &area, bool isMouseOver, bool isMouseDown, ConcertinaPanel &, Component &)=0
Public Member Functions inherited from ProgressBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawProgressBar (Graphics &, ProgressBar &, int width, int height, double progress, const String &textToShow)=0
| Draws a progress bar. More...
virtual bool | isProgressBarOpaque (ProgressBar &)=0
Public Member Functions inherited from StretchableLayoutResizerBar::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual void | drawStretchableLayoutResizerBar (Graphics &, int w, int h, bool isVerticalBar, bool isMouseOver, bool isMouseDragging)=0
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::KeyMappingEditorComponentMethods
virtual | ~KeyMappingEditorComponentMethods ()=default
virtual void | drawKeymapChangeButton (Graphics &, int width, int height, Button &, const String &keyDescription)=0
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::AudioDeviceSelectorComponentMethods
virtual | ~AudioDeviceSelectorComponentMethods ()=default
virtual void | drawLevelMeter (Graphics &, int width, int height, float level)=0
Public Member Functions inherited from ExtraLookAndFeelBaseClasses::LassoComponentMethods
virtual | ~LassoComponentMethods ()=default
virtual void | drawLasso (Graphics &, Component &lassoComp)=0
Public Member Functions inherited from SidePanel::LookAndFeelMethods
virtual | ~LookAndFeelMethods ()=default
virtual Font | getSidePanelTitleFont (SidePanel &)=0
virtual Justification | getSidePanelTitleJustification (SidePanel &)=0
virtual Path | getSidePanelDismissButtonShape (SidePanel &)=0

## Additional Inherited Members
Static Public Member Functions inherited from LookAndFeel_V2
static void | drawBevel (Graphics &, int x, int y, int width, int height, int bevelThickness, const Colour &topLeftColour=Colours::white, const Colour &bottomRightColour=Colours::black, bool useGradient=true, bool sharpEdgeOnOutside=true)
| Draws a 3D raised (or indented) bevel using two colours. More...
static void | drawGlassSphere (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness) noexcept
| Utility function to draw a shiny, glassy circle (for round LED-type buttons). More...
static void | drawGlassPointer (Graphics &, float x, float y, float diameter, const Colour &, float outlineThickness, int direction) noexcept
static void | drawGlassLozenge (Graphics &, float x, float y, float width, float height, const Colour &, float outlineThickness, float cornerSize, bool flatOnLeft, bool flatOnRight, bool flatOnTop, bool flatOnBottom) noexcept
| Utility function to draw a shiny, glassy oblong (for text buttons). More...
Static Public Member Functions inherited from LookAndFeel
static LookAndFeel & | getDefaultLookAndFeel () noexcept
| Returns the current default look-and-feel for a component to use when it hasn't got one explicitly set. More...
static void | setDefaultLookAndFeel (LookAndFeel *newDefaultLookAndFeel) noexcept
| Changes the default look-and-feel. More...

## Detailed Description

The original JUCE look-and-feel, as used back from 2002 to about 2007ish.

See also
  LookAndFeel, LookAndFeel_V2, LookAndFeel_V3

## Constructor & Destructor Documentation

## ◆ LookAndFeel_V1()

LookAndFeel_V1::LookAndFeel_V1 | ( |  | ) |

## ◆ ~LookAndFeel_V1()

LookAndFeel_V1::~LookAndFeel_V1 | ( |  | ) |
| override

## Member Function Documentation

## ◆ drawButtonBackground()

void LookAndFeel_V1::drawButtonBackground | ( | Graphics & | ,
|  | Button & | ,
|  | const Colour & | backgroundColour,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

## ◆ drawToggleButton()

void LookAndFeel_V1::drawToggleButton | ( | Graphics & | ,
|  | ToggleButton & | ,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Draws the contents of a standard ToggleButton.

Implements Button::LookAndFeelMethods.

## ◆ drawTickBox()

void LookAndFeel_V1::drawTickBox | ( | Graphics & | ,
|  | Component & | ,
|  | float | x,
|  | float | y,
|  | float | w,
|  | float | h,
|  | bool | ticked,
|  | bool | isEnabled,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| overridevirtual

Implements Button::LookAndFeelMethods.

## ◆ drawProgressBar()

void LookAndFeel_V1::drawProgressBar | ( | Graphics & | ,
|  | ProgressBar & | ,
|  | int | width,
|  | int | height,
|  | double | progress,
|  | const String & | textToShow
| ) |  |
| overridevirtual

Draws a progress bar.

If the progress value is less than 0 or greater than 1.0, this should draw a spinning bar that fills the whole space (i.e. to say that the app is still busy but the progress isn't known). It can use the current time as a basis for playing an animation.

(Used by progress bars in AlertWindow).

Implements ProgressBar::LookAndFeelMethods.

## ◆ drawScrollbarButton()

void LookAndFeel_V1::drawScrollbarButton | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | width,
|  | int | height,
|  | int | buttonDirection,
|  | bool | isScrollbarVertical,
|  | bool | isMouseOverButton,
|  | bool | isButtonDown
| ) |  |
| overridevirtual

Draws one of the buttons on a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  width | the width of the button
  height | the height of the button
  buttonDirection | the direction of the button, where 0 = up, 1 = right, 2 = down, 3 = left
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  isMouseOverButton | whether the mouse is currently over the button (also true if it's held down)
  isButtonDown | whether the mouse button's held down

Implements ScrollBar::LookAndFeelMethods.

## ◆ drawScrollbar()

void LookAndFeel_V1::drawScrollbar | ( | Graphics & | g,
|  | ScrollBar & | scrollbar,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | bool | isScrollbarVertical,
|  | int | thumbStartPosition,
|  | int | thumbSize,
|  | bool | isMouseOver,
|  | bool | isMouseDown
| ) |  |
| overridevirtual

Draws the thumb area of a scrollbar.

Parameters

  g | the context to draw into
  scrollbar | the bar itself
  x | the x position of the left edge of the thumb area to draw in
  y | the y position of the top edge of the thumb area to draw in
  width | the width of the thumb area to draw in
  height | the height of the thumb area to draw in
  isScrollbarVertical | true if it's a vertical bar, false if horizontal
  thumbStartPosition | for vertical bars, the y coordinate of the top of the thumb, or its x position for horizontal bars
  thumbSize | for vertical bars, the height of the thumb, or its width for horizontal bars. This may be 0 if the thumb shouldn't be drawn.
  isMouseOver | whether the mouse is over the thumb area, also true if the mouse is currently dragging the thumb
  isMouseDown | whether the mouse is currently dragging the scrollbar

Implements ScrollBar::LookAndFeelMethods.

## ◆ getScrollbarEffect()

ImageEffectFilter * LookAndFeel_V1::getScrollbarEffect | ( |  | ) |
| overridevirtual

Returns the component effect to use for a scrollbar.

Implements ScrollBar::LookAndFeelMethods.

## ◆ drawTextEditorOutline()

void LookAndFeel_V1::drawTextEditorOutline | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | TextEditor & |
| ) |  |
| overridevirtual

Implements TextEditor::LookAndFeelMethods.

## ◆ drawPopupMenuBackground()

void LookAndFeel_V1::drawPopupMenuBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height
| ) |  |
| overridevirtual

Fills the background of a popup menu component.

Reimplemented from PopupMenu::LookAndFeelMethods.

## ◆ drawMenuBarBackground()

void LookAndFeel_V1::drawMenuBarBackground | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isMouseOverBar,
|  | MenuBarComponent & |
| ) |  |
| overridevirtual

Implements PopupMenu::LookAndFeelMethods.

## ◆ drawComboBox()

void LookAndFeel_V1::drawComboBox | ( | Graphics & | ,
|  | int | width,
|  | int | height,
|  | bool | isButtonDown,
|  | int | buttonX,
|  | int | buttonY,
|  | int | buttonW,
|  | int | buttonH,
|  | ComboBox & |
| ) |  |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

## ◆ getComboBoxFont()

Font LookAndFeel_V1::getComboBoxFont | ( | ComboBox & |  | ) |
| overridevirtual

Implements ComboBox::LookAndFeelMethods.

## ◆ drawLinearSlider()

void LookAndFeel_V1::drawLinearSlider | ( | Graphics & | ,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | float | sliderPos,
|  | float | minSliderPos,
|  | float | maxSliderPos,
|  | const Slider::SliderStyle | ,
|  | Slider & |
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getSliderThumbRadius()

int LookAndFeel_V1::getSliderThumbRadius | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ createSliderButton()

Button * LookAndFeel_V1::createSliderButton | ( | Slider & | ,
|  | bool | isIncrement
| ) |  |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ getSliderEffect()

ImageEffectFilter * LookAndFeel_V1::getSliderEffect | ( | Slider & |  | ) |
| overridevirtual

Implements Slider::LookAndFeelMethods.

## ◆ drawCornerResizer()

void LookAndFeel_V1::drawCornerResizer | ( | Graphics & | ,
|  | int | w,
|  | int | h,
|  | bool | isMouseOver,
|  | bool | isMouseDragging
| ) |  |
| overridevirtual

Implements ResizableWindow::LookAndFeelMethods.

## ◆ createDocumentWindowButton()

Button * LookAndFeel_V1::createDocumentWindowButton | ( | int | buttonType | ) |
| overridevirtual

Implements DocumentWindow::LookAndFeelMethods.

## ◆ positionDocumentWindowButtons()

void LookAndFeel_V1::positionDocumentWindowButtons | ( | DocumentWindow & | ,
|  | int | titleBarX,
|  | int | titleBarY,
|  | int | titleBarW,
|  | int | titleBarH,
|  | Button * | minimiseButton,
|  | Button * | maximiseButton,
|  | Button * | closeButton,
|  | bool | positionTitleBarButtonsOnLeft
| ) |  |
| overridevirtual

Implements DocumentWindow::LookAndFeelMethods.

The documentation for this class was generated from the following file:

- juce_LookAndFeel_V1.h